﻿<!DOCTYPE html>
<html lang="en-US">
<head>
 <title>MetaData Demonstration</title>
  <script src="ClientGlobalContext.js.aspx" type="text/javascript"></script>
 <script src="a422_MetadataScripts.js" type="text/javascript"></script>
 <script src="a422_FetchUtil.js" type="text/javascript"></script>
 <script type="text/javascript">
 
  function getEntities() {
 
   //Retrieve entities
   SDK.Metadata.RetrieveAllEntities(SDK.Metadata.EntityFilters.Entity,
    false,
    successRetrieveAllEntities,
	errorRetrieveAllEntities);
   }

  function successRetrieveAllEntities(entityMetadataCollection) {

   for (var i = 0; i < entityMetadataCollection.length; i++) {

    var entity = entityMetadataCollection[i];
    var eLabels = entity.DisplayName.LocalizedLabels;
	var eDisplay;
	var eLogical;
	var checkName;
        
    if (eLabels.length > 0)
	    {
	    var optn = document.createElement("OPTION");

		try
			{
			eDisplay = eLabels[0].Label;
			}
		catch(err)
			{
			eDisplay = entity.LogicalName;
			}
	    eLogical = entity.LogicalName;
	    checkName = eLogical.substring(8,0);
	    if (checkName.toLowerCase() == "a422_dom" || eLogical.toLowerCase() == "a422_applicationtype" || eLogical.toLowerCase() == "relationshiprole")
	    	{
		    optn.text = eDisplay;
		    optn.value = eLogical;
		    document.getElementById("lstEntity").options.add(optn);
	    	}
	    }

   }
  }
  
  function errorRetrieveAllEntities(error) {
    alert(error.message);
  }
  

  function retrieveAttributes() 
  {
    //Get label and value from dropdown to set crm form values
    var domainList = document.getElementById("lstEntity");
    var entityLogicalName= domainList.options[domainList.selectedIndex].value;
    var eDisplayName = domainList.options[domainList.selectedIndex].text;
    
    //Set crm form values for domain
    window.parent.Xrm.Page.getAttribute("a422_domain").setValue(eDisplayName);
    window.parent.Xrm.Page.getAttribute("a422_domainschema").setValue(entityLogicalName);
    
    //Clear previously set values on CRM form for Attribute and Lookup Value
    window.parent.Xrm.Page.getAttribute("a422_attribute").setValue(null);
    window.parent.Xrm.Page.getAttribute("a422_attributeschema").setValue(null);
    window.parent.Xrm.Page.getAttribute("a422_crmname").setValue(null);
    window.parent.Xrm.Page.getAttribute("a422_crmid").setValue(null);
    
    //Clear dropdown list before adding new values
    var ddlAtt = document.getElementById("lstAttribute");
	var ddlVals = document.getElementById("lstAttValue");
	ClearDropDown(ddlAtt);
	ClearDropDown(ddlVals);

	if (entityLogicalName != null && entityLogicalName !== "")
	{
	    SDK.Metadata.RetrieveEntity(SDK.Metadata.EntityFilters.Attributes,
	    entityLogicalName,
	    null,
	    false,
	    function (entityMetadata) { successRetrieveEntity(entityLogicalName, entityMetadata); },
		errorRetrieveEntity);
	  	}
	}

  function successRetrieveEntity(logicalName, entityMetadata) {
		
   for (var i = 0; i < entityMetadata.Attributes.length; i++) {
    
    var attribute = entityMetadata.Attributes[i];
    var attLabels = attribute.DisplayName.LocalizedLabels;
	var attDisplay;
        
    if (attLabels.length > 0)
	    {
	    var optn = document.createElement("OPTION");
		
		try
			{
			attDisplay = attLabels[0].LocalizedLabel.Label;
			}
		catch(err)
			{
			attDisplay = attribute.LogicalName;
			}
			
	    var attLogical = attribute.LogicalName;
	    var checkName = attLogical.substring(4,0);

    	if (checkName.toLowerCase() == "a422" || attLogical.toLowerCase() == "name")
	    	{
		    optn.text = attDisplay;
		    optn.value = attLogical;
		    document.getElementById("lstAttribute").options.add(optn);
		    }
	    }

   }
  }
  
  function errorRetrieveEntity(error) {
    alert(error.message);
  }
    
  function getDomData()
  {
 	//Get dropdownvalues
	var domainList = document.getElementById("lstEntity");
    var domName = domainList.options[domainList.selectedIndex].value;
       
    var attList = document.getElementById("lstAttribute");
    var attName = attList.options[attList.selectedIndex].value;
    var attDisplay = attList.options[attList.selectedIndex].text;
    
    //Set parent CRM form field values
    window.parent.Xrm.Page.getAttribute("a422_attribute").setValue(attDisplay);
    window.parent.Xrm.Page.getAttribute("a422_attributeschema").setValue(attName);
    
    //Clear existing CRM form data for Lookup Value    
    window.parent.Xrm.Page.getAttribute("a422_crmname").setValue(null);
    window.parent.Xrm.Page.getAttribute("a422_crmid").setValue(null);
    
    //Clear dropdown list before adding new value
	var attVals = document.getElementById("lstAttValue");
	ClearDropDown(attVals);


	if (attName != null && attName != "")
	{
		//Set up the fecth service
		var _oService; 
		var _sOrgName = GetGlobalContext().getOrgUniqueName();
		var _sServerUrl = GetGlobalContext().getServerUrl();
		
		
		//Build the fecth statement
		var sFetch = "<fetch version='1.0' output-format='xml-platform' mapping='logical' distinct='false'>" +
		"<entity name='" + domName + "'>" +
		"<attribute name='" + attName + "' />" +
		"<order attribute='" + attName + "' descending='false' />" +
		"</entity>" +
		"</fetch>";
		
		//alert(sFetch);
		
		//Execute fecth call (FetchUtil.js) and call myCallBack funtion on success
		_oService = new FetchUtil(_sOrgName, _sServerUrl); 
		var oEntity = _oService.Fetch(sFetch, myCallBack); 
		} 
	  
	  		function myCallBack(results){ 
		//Get record (entity) collection from xml response
		var records = results.getElementsByTagName("a:Entity");
			
		
		for (var i = 0; i < records.length; i++){ 
			var rAtRoot = records[i].getElementsByTagName("a:Attributes")[0].getElementsByTagName("a:KeyValuePairOfstringanyType");
			var rName = rAtRoot[0].getElementsByTagName("b:value")[0].childNodes[0].nodeValue;
			var rValue = rAtRoot[1].getElementsByTagName("b:value")[0].childNodes[0].nodeValue;
			//rLink = rAtRoot[1].getElementsByTagName("b:value")[0].text;
			//rNewCat = records[i].getElementsByTagName("a:FormattedValues")[0].getElementsByTagName("a:KeyValuePairOfstringstring")[0].getElementsByTagName("b:value")[0].text;
			
			var optn = document.createElement("OPTION");
		    optn.text = rName;
		    optn.value = rValue;
		    attVals.options.add(optn);
	  }
  	}
  }
  
  //Clears specified dropdown list
  function ClearDropDown(ddl) 
	{
 
  	var len = ddl.options.length-1;
 
    	for (i=0; i<len; i++) {
        ddl.remove(1); //Removes second item in collection leaving the first empy option in place

    	}
 	}
 	
 function setGuid()
 {
    var ddlVals = document.getElementById("lstAttValue");
    var lVal = ddlVals.options[ddlVals.selectedIndex].text;
    var lGuid = ddlVals.options[ddlVals.selectedIndex].value;
    
    //Set parent CRM form field values
    window.parent.Xrm.Page.getAttribute("a422_crmname").setValue(lVal);
    window.parent.Xrm.Page.getAttribute("a422_crmid").setValue(lGuid);
}
  
 </script>
 <style type="text/css">
 body {
	 background-color: #f6f8fa;
	 font-family: "Segoe UI", Tahoma, Arial;
	 font-size: 11px;
 }
 td.Label {
	 text-align: left;
	 color: #3b3b3b;
 }
 .myddl {
	 color: #000000;
	 width: 100%;
	 font-family: "Segoe UI", Tahoma, Arial;
	 font-size: 11px;
 }
 td {
	 padding: 5px;
 }
 </style>
</head>
<body onload="getEntities()">
  <table style="width:100%;">
  
<COLGROUP><COL width=115>
<COL>
<COL width=135>
<COL>
<tbody>
 <tr>
 <td class="Label">
	 Domain Entity</td>
 <td>
	 <select class="myddl" name="Domain Entity" id="lstEntity" onchange="retrieveAttributes();">
	 <option></option>
	 </select>
	 </td>
 <td class="Label" style="padding-left:20px">
	 Domain Attribute</td>
 <td>
	 <select class="myddl" name="Domain Attribute" id="lstAttribute" onchange="getDomData();">
	 <option></option>
	 </select>
	 </td>
 </tr>
  <tr>
 <td class="Label">Attribute Value</td>
 <td><select class="myddl" name="Attribute Value" id="lstAttValue" onchange="setGuid();">
 <option></option>
 </select>
 </td>
 <td>&nbsp;</td>
 <td></td>
 </tr>
</tbody>
 </table>
</body>
</html>
<!--</snippetMetaDataDemo>-->
